#!/usr/bin/env python
# -*- coding: utf-8 -*-

# An ES Tools replacement on new CS:S update by fratacos
# Version 0.37

#[Added]
#adddownload, armor, armoradd, getarmor, setarmor, cashadd, setcash, slay, damage, and regclientcmd
#load custom events in "addons/est/es_tools.res"

#[Fixed]
#playerselection type error

#[Known Issues]
#est_team is not the same as EST
#est_spawn cause crush when double triggered in a near time.
#all commands are in lower cases

#[TODO]
#ammo, health, burn, extinguish, disolve, getviewprop, rocket, jetpack, shake, showmenu, NearCoord, IsAlive, RoundDecimal, GetViewCoord, playplayer, randplayer, SetClipAmmo, est_give, pushto, 
#est_allowadvanceddrop
#est_modplayerweapon
#est_restrictall could be possible with -1 handle for all slots?

#[currently not possible]
#restrict*
#est_effect*
#est_enable_PerUserKeyEvents
#est_DeathSet

import es
#import nativetools as nt
import gamethread
import playerlib
import time
import vecmath

spawn_time = 0
spawn_queue = []
timer = 0
starttime = time.time()
regclientcmd_list = []

def adddownload(param):
	es.ServerCommand("es_stringtable downloadables %s" % param)
def armor(users, param, value):
	v = int(value)
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CCSPlayer.m_ArmorValue")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CCSPlayer.m_ArmorValue", v)
def armoradd(users, value):
	armor(users, "+", value)
def cash(users, param, value):
	v = int(value)
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CCSPlayer.m_iAccount")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CCSPlayer.m_iAccount", v)
def cashadd(users, value):
	cash(users, "+", value)
def csay(users, text):
	es.usermsg("create", "centermsg", "TextMsg")
	es.usermsg("write", "byte", "centermsg", 4)
	es.usermsg("write", "string", "centermsg", unicode(text))
	for userid in getusers(users):
		es.usermsg("send", "centermsg", userid)
	es.usermsg("delete", "centermsg")
def curtime():
	global timer
	return time.time() - timer
def damage(source, target, value):
	if str(source) == "0":
		for userid in getusers(target):
			es.ServerCommand("es_give %s point_hurt" % userid)
			es.ServerCommand('es_fire %s point_hurt addoutput "DamageType 2"' % userid)
			es.ServerCommand('es_fire %s point_hurt addoutput "Damage 10000"' % userid)
			es.ServerCommand('es_fire %s point_hurt Hurt' % userid)
		return
	for userid in getusers(source):
		source = userid
		break
	for userid in getusers(target):
		es.ServerCommand('es_fire %s !self addoutput "targetname mrdamage"' % userid)
	# es.ServerCommand("es_xtrick entity point_hurt")
	es.ServerCommand('es_give %s point_hurt' % source)
	es.ServerCommand('es_fire %s point_hurt Kill' % source)
	es.ServerCommand('es_fire %s point_hurt addoutput "Damage %d"' % (source, int(value)))
	es.ServerCommand('es_fire %s point_hurt addoutput "DamageType 2"' % source)
	es.ServerCommand('es_fire %s point_hurt addoutput "DamageTarget mrdamage"' % source)
	es.ServerCommand('es_fire %s point_hurt Hurt' % source)
	es.ServerCommand('es_fire %s player addoutput "targetname mrhuman"' % source)
def deafen(users, total, percent, fadeout, fadeback):
	for userid in getusers(users):
		es.fadevolume(userid, percent, fadeout, total, fadeback)
def deleteragdolls(users = 0):
	if str(users) == "0":
		es.ServerCommand("es_delayed 0.15 es_fire %s cs_ragdoll kill" % es.getuserid())
		return
	handles = []
	for userid in getusers(users):
		handles.append(es.getplayerhandle(userid))
	ragdolls = es.createentitylist("cs_ragdoll")
	for index in ragdolls:
		if es.getindexprop(index, "CCSRagdoll.m_hPlayer") in handles:
			setentname(index, "theragdoll")	
	es.ServerCommand("es_delayed 0.15 es_fire %s theragdoll kill" % es.getuserid())
def endround(time, reason):
	t = int(time)
	r = int(reason)
	if not (0 < r and r < 17):
		return
	data = [["#Target_Bombed", 2], ["#VIP_Escaped", 3], ["#VIP_Assassinated", 2], ["#Terrorists_Escaped", 2], ["#CTs_PreventEscape", 3], ["#Escaping_Terrorists_Neutralized", 3], ["#Bomb_Defused", 3], ["#CTs_Win", 3], ["#Terrorists_Win", 2], ["#Round_Draw", 0], ["#All_Hostages_Rescued", 3], ["#Target_Saved", 3], ["#Hostages_Not_Rescued", 2], ["#Terrorists_Not_Escaped", 3], ["#VIP_Not_Escaped", 2], ["#Game_Commencing", 0]]
	winner = data[r - 1][1]
	text = data[r - 1][0]
	es.event("initialize", "round_end")
	es.event("setint", "round_end", "winner", winner)
	es.event("setint", "round_end", "reason", r)
	es.event("setstring", "round_end", "message", text)
	es.event("fire", "round_end")
	gamethread.delayed(t, endround_delayed1, (t, text))
	gamethread.delayed(t + 0.20, endround_delayed2, (t, text))
def endround_delayed1(t, text):
	es.flags("remove", "cheat", "endround")
	es.ServerCommand("endround")
def endround_delayed2(t, text):
	es.flags("add", "cheat", "endround")
	if t >= 2:
		es.centermsg("")
	else:
		es.centermsg(text)
def entteleport(index, x, y, z):
	setentname(index, "theentity")
	es.ServerCommand('es_fire %s theentity addoutput "origin %d %d %d"' % (es.getuserid(), float(x), float(y), float(z)))
def fade(users, type, fadetime, totaltime, r, g, b, a):
	t = int(type)
	if t == 1:
		type = 2
	elif t == 0:
		type = 1
	else:
		type = 8 + 16
	es.usermsg("create", "fade", "Fade")
	es.usermsg("write", "short", "fade", int(fadetime) * 1000)
	es.usermsg("write", "short", "fade", int(totaltime) * 1000)
	es.usermsg("write", "short", "fade", int(type))
	es.usermsg("write", "byte", "fade", int(r))
	es.usermsg("write", "byte", "fade", int(g))
	es.usermsg("write", "byte", "fade", int(b))
	es.usermsg("write", "byte", "fade", int(a))
	for userid in getusers(users):
		es.usermsg("send", "fade", userid)
	es.usermsg("delete", "fade")
def freeze(users, param = 1):
	for userid in getusers(users):
		movetype = es.getplayerprop(userid, "CBaseEntity.movetype")
		if str(param) == "1":
			if movetype & 2:
				es.setplayerprop(userid, "CBaseEntity.movetype", movetype - 2)
		else:
			if not movetype & 2:
				es.setplayerprop(userid, "CBaseEntity.movetype", movetype + 2)
def getarmor(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CCSPlayer.m_ArmorValue")
def getgun(userid):
	return playerlib.getPlayer(userid).weapon
def getkills(userid):
	# Currently hard coded with@CS:S
	index = es.getentityindex("cs_player_manager")
	return es.getindexprop(index, "CPlayerResource.m_iScore.%.3d" % playerlib.getPlayer(userid).attributes["index"])
def god(users, param = 1):
	for userid in getusers(users):
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		if not dead:
			if str(param) == "1":
				es.setplayerprop(userid, "CBasePlayer.m_lifeState", 0)
			else:
				es.setplayerprop(userid, "CBasePlayer.m_lifeState", 512)
def hsay(users, text):
	es.usermsg("create", "hudhint", "HintText")
	es.usermsg("write", "string", "hudhint", unicode(text))
	for userid in getusers(users):
		es.usermsg("send", "hudhint", userid)
	es.usermsg("delete", "hudhint")
def killadd(users, v):
	kills(users, "+", v)
def kills(users, param, v):
	value = int(v)
	trigger = es.getuserid()
	es.ServerCommand("es_give %s game_score" % trigger)
	es.ServerCommand('es_fire %s game_score addoutput "spawnflags 1"' % trigger)
	if param == "+":
		apply = value
	if param == "-":
		apply = -value
	for userid in getusers(users):
		if param == "=":
			apply = value - getkills(userid)
		es.ServerCommand('es_fire %s game_score addoutput "points %d"' % (userid, apply))
		es.ServerCommand("es_fire %s game_score ApplyScore" % userid)
	es.ServerCommand("es_fire %s game_score kill" % trigger)
def killset(users, v):
	kills(users, "=", v)
def loop(variable, users, command):
	es.msg([variable, users, command])
	for userid in getusers(users):
		es.ServerCommand("%s %s" % (variable, userid))
		es.ServerCommand(command)
def motd(users, title, type, msg):
	data = { "title":title, "type":type, "msg":msg }
	es.usermsg('create', 'panel', 'VGUIMenu')
	es.usermsg('write', 'string', 'panel', "info")
	es.usermsg('write', 'byte', 'panel', 1)
	es.usermsg('write', 'byte', 'panel', len(data))
	for item in data:
		es.usermsg('write', 'string', 'panel', item)
		es.usermsg('write', 'string', 'panel', data[item])
	for userid in getusers(users):
		es.usermsg('send', 'panel', userid)
	es.usermsg('delete', 'panel')
def motd_f(users, title, command, path):
	motd(users, unicode(title), "3", path)
def motd_t(users, title, command, text):
	motd(users, unicode(title), "0", unicode(text))
def motd_w(users, title, command, url):
	motd(users, unicode(title), "2", url)
def msg(users, value):
	for userid in getusers(users):
		es.tell(userid, "#multi", value)
def name(users, value):
	for userid in getusers(users):
		if es.getplayersteamid(userid) == "BOT":
			es.botsetvalue(userid, "name", value)
		else:
			es.cexec(userid, "name %s" % value)
def physpush(users, x, y, z):
	for userid in getusers(users):
		vec = vecmath.vector(es.getplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity"))
		es.setplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity", "%f,%f,%f" % (float(x) + vec[0], float(y) + vec[1], float(z) + vec[2]))
def regclientcmd(command, type):
	global regclientcmd_list
	if str(type) == "1":
		t = 1
	else:
		t = 0
	regclientcmd_list.append([command, t])
def remove(param):
	es.ServerCommand("es_fire %s %s kill" % (es.getuserid(), param))
def removeidle(param):
	if param == "weapon":
		weapons = ["weapon_ak47", "weapon_aug", "weapon_awp", "weapon_c4", "weapon_deagle", "weapon_elite", "weapon_famas", "weapon_fiveseven", "weapon_flashbang", "weapon_g3sg1", "weapon_galil", "weapon_glock", "weapon_hegrenade", "weapon_knife", "weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_mac10", "weapon_mp5navy", "weapon_p228", "weapon_p90", "weapon_scout", "weapon_sg550", "weapon_sg552", "weapon_smokegrenade", "weapon_tmp", "weapon_ump45", "weapon_usp", "weapon_xm1014"]
		for weapon in weapons:
			removeidle(weapon)
		return
	weapon = es.createentitylist(param)
	for index in weapon:
		if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") == -1:
			setentname(index, "theweapon")
	es.ServerCommand("es_fire %s theweapon kill" % es.getuserid())
def removeweapon(users, param):
	if str(param) in ["1", "2", "3", "4"]:
		for userid in getusers(users):
			handle = es.getplayerhandle(userid)
			# name = nt.weaponSlot(userid, int(param) - 1)
			player = playerlib.getPlayer(userid)
			no = int(param)
			if no == 1:
				name = ["weapon_ak47", "weapon_sig552", "weapon_mac10", "weapon_sg550", "weapon_scout", "weapon_awp", "weapon_famas", "weapon_m4a1", "weapon_mp5navy", "weapon_ump45", "weapon_g3sg1", "weapon_xm1014", "weapon_p90", "weapon_aug"]
			if no == 2:
				name = ["weapon_glock", "weapon_usp", "weapon_deagle", "weapon_elite", "weapon_p228", "weapon_fiveseven"]
			if no == 3:
				name = ["weapon_knife"]
			if no == 4:
				name = ["weapon_hegrenade", "weapon_smokegrenade", "weapon_flashbang"]
			weapon = []
			for item in name:
				weapon.extend(es.createentitylist(item))
			for index in weapon:
				if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") == handle:
					setentname(index, "theweapon")
					if no in [1, 2]:
						break
	else:
		handles = []
		for userid in getusers(users):
			handles.append(es.getplayerhandle(userid))
		weapon = es.createentitylist(param)
		for index in weapon:
			if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") in handles:
				setentname(index, "theweapon")
	es.ServerCommand("es_fire %s theweapon kill" % es.getuserid())
def setarmor(users, value):
	armor(users, "=", value)
def setcash(users, value):
	cash(users, "=", value)
def setentname(index, param):
	# nt.entitySetName(index, param)
	es.setentityname(index, param)
def setgravity(users, ratio):
	for userid in getusers(users):
		es.ServerCommand('es_xfire %s !self addoutput "gravity %f"' % (userid, float(ratio)))
def setmodel(users, model):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.setModel(model)
def setplayercolor(users, r, g, b, a, weapon):
	w = int(weapon)
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.setColor(int(r), int(g), int(b), int(a))
		if w == 1:
			player.setWeaponColor(int(r), int(g), int(b), int(a))
def slay(users):
	for userid in getusers(users):
		health = es.getplayerprop(userid, "CBasePlayer.m_iHealth")
		damage(0, userid, health + 1)
def spawn(users, param = 0):
	global spawn_time
	count = 1
	for userid in getusers(users):
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		if int(param) == 0 and not dead:
			continue
		es.setplayerprop(userid, "CCSPlayer.m_iPlayerState", 0)
		if spawn_time == 0:
			time = 0.05
		else:
			diff = curtime() - spawn_time
			if diff <= 0:
				time = -diff
			else:
				time = 0.05
		time += 0.15
		gamethread.delayed(time, es.spawnplayer, userid)
		spawn_time = time + curtime()
		count += 1
def speed(users, value):
	for userid in getusers(users):
		es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", value)
def stripplayer(users, param = 0):
	rcontrigger = es.getuserid()
	es.ServerCommand("es_give %s player_weaponstrip" % trigger)
	for userid in getusers(users):
		if str(param) != "0":
			es.ServerCommand("es_fire %s player_weaponstrip StripWeaponsAndSuit" % userid)
		else:
			es.ServerCommand("es_fire %s player_weaponstrip Strip" % userid)
	es.ServerCommand("es_fire %s Strip kill" % trigger)
def team(users, no):
	for userid in getusers(users):
		oldteam = es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
		es.setplayerprop(userid, "CBaseEntity.m_iTeamNum", int(no))
		es.changeteam(userid, int(no))
		es.event("initialize", "player_team")
		es.event("setint", "player_team", "userid", userid)
		es.event("setint", "player_team", "team", int(no))
		es.event("setint", "player_team", "oldteam", oldteam)
		es.event("fire", "player_team")
def teleport(users, x, y, z):
	for userid in getusers(users):
		es.setpos(userid, float(x), float(y), float(z))
def unregclientcmd(command):
	global regclientcmd_list
	if [command, 0] in regclientcmd_list:
		regclientcmd_list.remove([command, 0])
	if [command, 1] in regclientcmd_list:
		regclientcmd_list.remove([command, 1])
def uptime():
	global starttime
	return time.time() - starttime

def es_player_chat(event_var):
	userid = event_var["userid"]
	if int(userid) <= 0:
		return
	team = es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
	flag = 0
	if team == 1:
		if not int(event_var["teamonly"]):
			players = playerlib.getPlayerList("#alive")
			type = "#Cstrike_Chat_AllSpec"
			flag = 1
	elif es.getplayerprop(userid, "CBasePlayer.pl.deadflag") == 1:
		flag = 1
		if int(event_var["teamonly"]):
			if team == 2:
				str = "#t,#alive"
				type = "#Cstrike_Chat_T_Dead"
			if team == 3:
				str = "#ct,#alive"
				type = "#Cstrike_Chat_CT_Dead"
			players = playerlib.getPlayerList(str)
		else:
			players = playerlib.getPlayerList("#alive")
			type = "#Cstrike_Chat_AllDead"
	if flag:
		name = '"%s"' % es.getplayername(userid)
		text = '"%s"' % event_var["text"]
		es.usermsg('create', 'saytext', 'SayText2')
		es.usermsg('write', 'byte', 'saytext', event_var["es_userindex"])
		es.usermsg('write', 'byte', 'saytext', 1)
		es.usermsg('write', 'string', 'saytext', type)
		es.usermsg('write', 'string', 'saytext', name)
		es.usermsg('write', 'string', 'saytext', text)
		for player in players:
			es.usermsg('send', 'saytext', player.userid)
		es.usermsg('delete', 'saytext')

def es_map_start(event_var):
	global spawn_time
	global spawn_queue
	spawn_time = 0
	spawn_queue = []

def round_start(event_var):
	global timer
	timer = time.time()

def clientcommandfilter(userid, args):
	global regclientcmd_list
	for item in regclientcmd_list:
		if item[0] == args[0]:
			es.event("initialize", "est_cmdhook")
			es.event("setint", "est_cmdhook", "userid", userid)
			es.event("setstring", "est_cmdhook", "hooktext", args[0])
			es.event("setstring", "est_cmdhook", "commandstring", str(args[1:]))
			es.event("fire", "est_cmdhook")
			if item[1]: return True
			else: return False
	return True

def getusers(users):
	#TODO: http://www.eventscripts.com/pages/Est_PlayerSelection
	# Python style #alive, #all, #bot, #ct, #dead, #human, #spec, #t, #un
	# ex: #alive,#ct (for CT who is alive)
	# EST style #a, #c, #3, #t, #2, #s, #1, #u, #0, #h, #b, #l, #d
	# ex: #23!d (for all T and CT who is alive)
	# issue 1: #ct (use #tc or #23 instead for EST style)
	# issue 2: names start with # are not supported
	pyfilter = ["#alive", "#all", "#bot", "#ct", "#dead", "#human", "#spec", "#t", "#un"]
	if str(users)[0] == "#":
		status = 0
		notfilter = ""
		if "," in users:
			status = 1
		if "!" in users:
			all = users.split("!")
			users = all[0]
			notfilter = all[1]
			status = 2
		if status == 0:
			if users in pyfilter:
				status = 1
			else:
				status = 2
		if status == 2:
			est = [["t","#t"], ["c","#ct"], ["3","#ct"], ["2","#t"], ["s","#spec"], ["1","#spec"], ["u","#un"], ["h","#human"], ["b","#bot"], ["l","#alive"], ["a","#all"], ["d","#dead"] ]
			filter = []
			for item in est:
				if item[0] in users:
					idlist = playerlib.getUseridList(item[1])
					filter.extend(idlist)
			users = set(filter)
			if notfilter != "":
				filter = []
				for item in est:
					if item[0] in notfilter:
						idlist = playerlib.getUseridList(item[1])
						filter.extend(idlist)
				notfilter = set(filter)
				for item in notfilter:
					users.remove(item)
		else:
			users = playerlib.getUseridList(users)
	else:
		newusers = []
		all = playerlib.getUseridList("#all")
		for userid in all:
			if users == es.getplayersteamid(userid):
				newusers.append(userid)
			elif str(users) in es.getplayername(userid):
				newusers.append(userid)
		if newusers != []:
			users = newusers
	if not hasattr(users, "__iter__"):
		users = (users,)
	return users

def unicode(text):
	# for unicode texts in usermsg
	status = 1
	error = ":; "
	for item in error:
		if item in text:
			status = 0
	if status:
		msg = '"' + text + '"'
	else:
		msg = text
	return msg